<?php

if (!function_exists('iconv_get_encoding')) {
    function iconv_get_encoding($type)
    {
        if (extension_loaded('mb_string')) {
            switch ($type) {
                case 'input_encoding':
                case 'internal_encoding':
                    return mb_internal_encoding();
                    break;
                case 'output_encoding':
                    return mb_http_output();
                    break;
                case 'all':
                    return array(
                        'input_encoding' => mb_internal_encoding(),
                        'internal_encoding' => mb_internal_encoding(),
                        'output_encoding' => mb_internal_encoding(),
                    );

            }

            return FALSE;
        }
    }
}

if (!function_exists('iconv_set_encoding')) {
    function iconv_set_encoding($type, $charset)
    {
        if (extension_loaded('mb_string')) {
            switch ($type) {
                case 'input_encoding':
                case 'internal_encoding':
                    return mb_internal_encoding($charset);
                    break;
                case 'output_encoding':
                    return mb_http_output($charset);
                    break;
            }
        }

        return FALSE;
    }
}

if (!function_exists('iconv_substr')) {
    function iconv_substr($str, $offset, $length=0, $charset=NULL)
    {
        if (extension_loaded('mb_string')) {
            if (is_null($charset)) {
                $charset = mb_internal_encoding();
            }
            return mb_substr($str, $offset, $length, $charset);
        }

        return substr($str, $offset, $length);
    }
}

if (!function_exists('iconv_strpos')) {
    function iconv_strpos($haystack, $needle, $offset=0, $charset=NULL)
    {
        if (extension_loaded('mb_string')) {
            if (is_null($charset)) {
                $charset = mb_internal_encoding();
            }
            return mb_strpos($haystack, $needle, $offset, $charset);
        }

        return strpos($haystack, $needle, $offset);
    }
}

if (!function_exists('iconv_strrpos')) {
    function iconv_strrpos($haystack, $needle, $charset=NULL)
    {
        if (extension_loaded('mb_string')) {
            if (is_null($charset)) {
                $charset = mb_internal_encoding();
            }
            return mb_strrpos($haystack, $needle, $charset);
        }

        return strrpos($haystack, $needle);
    }
}

if (!function_exists('iconv_strlen')) {
    function iconv_strlen($str, $charset=NULL)
    {
        if (extension_loaded('mb_string')) {
            if (is_null($charset)) {
                $charset = mb_internal_encoding();
            }
            return mb_strlen($str, $charset);
        }

        return strlen($str);
    }
}

if (!function_exists('mb_strtolower')) {
    function mb_strtolower($str, $encoding=NULL) {
        return strtolower($str);
    }
}

if (!function_exists('iconv')) {
    function iconv($in_charset, $out_charset, $str)
    {
        return function_exists('mb_convert_encoding ')
            ? mb_convert_encoding ($str, $out_charset, $in_charset)
            : $str;
    }
}